G4C

winbig -1 -1 200 13 "WildCard Select"
wintype 01010000
varpath "climaster/*/functions.g"

xonopen
update routine.g 1 ""
setgad routine.g 1 on

xonrmb
guiclose routine.g

xtextin 0 0 0 0 "" cm_sel "" 30
gadid 1
lvuse climaster $cm_srce
lvdir none
lvsearch $cm_sel ci first
lvmove #$$lv.line
while $$lv.line > ''
    lvmulti on
    lvsearch $cm_sel ci next
endwhile
guiclose routine.g

xroutine filetype
extract cm_select file cm_temp
extract cm_temp unquote cm_temp
cutvar cm_temp copy char 4 cm_pfix
extract cm_temp ext cm_sfix
ifexists dir $cm_select
    cm_icon = "cmst:icons/def_drawer.info"
    return
endif
if $cm_sfix == ".info"
    cm_temp = "icon"
    cm_icon = ""
elseif $cm_select H= "FORM????MODLVER"
or $cm_select H= "MMD?"
or $cm_pfix == "mod."
or $cm_sfix == ".smon"
    cm_temp = "modplay"
    cm_icon = "cmst:icons/def_mod.info"
    parsevar MODPLAYER
elseif $cm_select H= "@"
or $cm_sfix == ".guide"
    cm_temp = "guideprg"
    cm_icon = "cmst:icons/def_guide.info"
    parsevar GUIDEPROG
elseif $cm_select H= "PP"
    cm_temp = "ppdat"
    cm_icon = "cmst:icons/def_project.info"
    parsevar PPTXTPROG
elseif $cm_sfix == ".txt"
or $cm_sfix == ".doc"
or $cm_sfix == ".readme"
or $cm_sfix == ".bat"
or $cm_sfix == ".asc"
or $cm_sfix == ".ascii"
or $cm_sfix == ".html"
or $cm_sfix == ".htm"
    cm_temp = "read"
    cm_icon = "cmst:icons/def_readme.info"
elseif $cm_sfix == ".lha"
or $cm_sfix == ".lzx"
    cm_temp = "archive"
    cm_icon = ""
elseif $cm_sfix == ".dms"
    cm_temp = "dms"
    cm_icon = ""
elseif $cm_select H= "/*"
or $cm_sfix == ".rexx"
or $cm_sfix == ".arexx"
    cm_temp = "arexx"
    cm_icon = "cmst:icons/def_rexx.info"
elseif $cm_select H= "G4C"
or $cm_sfix == ".gc"
or $cm_sfix == ".g"
    cm_temp = "g4c"
    cm_icon = "cmst:icons/def_gui.info"
elseif $cm_select H= "FORM????ILBM"
or $cm_select H= "GIF"
or $cm_select H= "?PNG?"
    cm_temp = "picviewr"
    cm_icon = "cmst:icons/def_ilbm.info"
    parsevar PICVIEWER
elseif $cm_select H= "FORM????ANIM"
    cm_temp = "picviewr"
    cm_icon = "cmst:icons/def_anim.info"
    parsevar PICVIEWER
elseif $cm_select H= "??????JFIF"
    cm_temp = "jpgviewr"
    cm_icon = "cmst:icons/def_ilbm.info"
    parsevar JPGVIEWER
elseif $cm_select H= "FORM????8SVX"
or $cm_select H= "RIFF????WAVEfmt"
    cm_temp = "sampl"
    cm_icon = "cmst:icons/def_sample.info"
    parsevar SVXPLAYER
elseif $cm_select H= "%%%%"
    cm_temp = "runit"
    cm_icn = "cmst:icons/def_tool.info"
;elseif $cm_sfix = ""
elseif $cm_select H= "####"
    cm_temp = "read"
    cm_icon = "cmst:icons/def_project.info"
endif
if $cm_mode == "addicon"
    return
else
    gosub routine.g dblclk
endif

xroutine dblclk
if $cm_temp = "modplay"
andifexists file $$parse.0
    ifexists window sfxinfo
        cli '$STOPMUSIC'
    endif
    run '$MODPLAYER $cm_select'
    extract cm_select file cm_soundfile
    guiopen sfxinfo
    update sfxinfo 1 $cm_soundfile
    return
elseif $cm_temp = icon
    copy $cm_select t:cmicon.info
    guiload cmst:modules/info.g
    return
elseif $cm_temp = "guideprg"
andifexists file $$parse.0
    run '$GUIDEPROG $cm_select'
    return
elseif $cm_temp = "ppdat"
andifexists file $$parse.0
    run '$PPTXTPROG $cm_select'
    return
elseif $cm_temp = "read"
    guiload cmst:modules/reader.g
    return
elseif $cm_temp = "archive"
    cutvar cm_sfix copy char -3 cm_arc
    cli 'c:$cm_arc v $cm_select >env:tempfile'
    guiload cmst:modules/reader.g
    delete env:tempfile
    return
elseif $cm_temp = "dms"
    cm_mode = "DMS-VIEW"
    gosub dms.g vandt
    return
elseif $cm_temp = "arexx"
    gosub routine.g ramcheck
    cd $cm_srcedir
    extract cm_select file cm_rexxfile
    run 'sys:rexxc/rx $cm_rexxfile'
    return
elseif $cm_temp = "g4c"
    guiload $cm_select
    return
elseif $cm_temp = "picviewr"
andifexists file $$parse.0
    run '$PICVIEWER $cm_select'
    return
elseif $cm_temp = "jpgviewr"
andifexists file $$parse.0
    run '$JPGVIEWER $cm_select'
    return
elseif $cm_temp = "runit"
    gosub routine.g runfile
    return
elseif $cm_temp = "sampl"
andifexists file $$parse.0
    run '$SVXPLAYER $cm_select'
    return
else
    update climaster 8 "Unknown Filetype."
    return
endif

xroutine drives
num = 0
while $num < 4
    drv = DF
    appvar drv $num
    ifexists dos $drv
        appvar drv :
        lvadd $drv
    endif
    counter num inc 1
endwhile

xroutine ramcheck
extract cm_select unquote cm_select
cutvar cm_select copy char 5 cm_gpvar
if $cm_gpvar == "Ram D"
    cm_gpvar = "RAM"
    cutvar cm_select cut char 8 ""
    appvar cm_gpvar $cm_select
    cm_select = $cm_gpvar
    delvar cm_gpvar
endif

xroutine runfile
if $cm_mode == "run"
    run '$cm_select'
    cm_mode = ""
    update climaster 8 "Running File..."
else
    guiopen runreq.g
endif

xroutine funclist
..flist = "READ\nNEWCLI\nRUN\nEXECUTE\nCOPY\nRENAME\nMOVE\nCOMMENT\nDELETE"
append env:flist '\nMAKEDIR\nCOPY-AS\nCLONE\nADDICON\nSHOW\nMOVE-AS\nEDIT'
append env:flist '\nJOIN\nASSIGN\nPROTECT\nHUNT\nGETSIZE'
ifexists file c:lha
    append env:flist '\nLHA-ADD\nLHA-EXT\nLHA-TEST'
endif
ifexists file c:lzx
    append env:flist '\nLZX-ADD\nLZX-EXT\nLZX-TEST'
endif
ifexists file c:dms
    append env:flist '\nDMS-READ\nDMS-WRITE\nDMS-TEST'
endif
ifexists file libs:unpack.library
andifexists file c:unpunpack
andifexists file c:unplist
    append env:flist '\nUNPACK\nUNPACK-LIST'
endif
